diff --git a/src/rawSHA224_fmt_plug.c b/src/rawSHA224_fmt_plug.c
index bda6b9ad3c..f160b05a3e 100644
--- a/src/rawSHA224_fmt_plug.c
+++ b/src/rawSHA224_fmt_plug.c
@@ -99,7 +99,11 @@ static struct fmt_tests tests[] = {
 };
 
 #ifdef SIMD_COEF_32
+#if ARCH_LITTLE_ENDIAN==1
 #define GETPOS(i, index)		( (index&(SIMD_COEF_32-1))*4 + ((i)&(0xffffffff-3))*SIMD_COEF_32 + (3-((i)&3)) + (unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*SIMD_COEF_32*4 )
+#else
+#define GETPOS(i, index)		( (index&(SIMD_COEF_32-1))*4 + ((i)&(0xffffffff-3))*SIMD_COEF_32 + ((i)&3) + (unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*4*SIMD_COEF_32 )
+#endif
 static uint32_t (*saved_key);
 static uint32_t (*crypt_out);
 #else
@@ -192,7 +196,9 @@ static void *get_binary(char *ciphertext)
 	}
 
 #ifdef SIMD_COEF_32
+#if ARCH_LITTLE_ENDIAN==1
 	alter_endianity (out, DIGEST_SIZE);
+#endif
 #ifdef REVERSE_STEPS
 	sha224_reverse(outw);
 #endif
@@ -242,6 +248,7 @@ static void set_key(char *key, int index) {
 	uint32_t temp;
 
 	len = 0;
+#if ARCH_LITTLE_ENDIAN==1
 	while((unsigned char)(temp = *wkey++)) {
 		if (!(temp & 0xff00))
 		{
@@ -262,6 +269,28 @@ static void set_key(char *key, int index) {
 			goto key_cleaning;
 		}
 		*keybuf_word = JOHNSWAP(temp);
+#else
+	while((temp = *wkey++) & 0xff000000) {
+		if (!(temp & 0xff0000))
+		{
+			*keybuf_word = (temp & 0xff000000) | (0x80 << 16);
+			len++;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff00))
+		{
+			*keybuf_word = (temp & 0xffff0000) | (0x80 << 8);
+			len+=2;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff))
+		{
+			*keybuf_word = temp | 0x80U;
+			len+=3;
+			goto key_cleaning;
+		}
+		*keybuf_word = temp;
+#endif
 		len += 4;
 		keybuf_word += SIMD_COEF_32;
 	}
@@ -370,7 +399,9 @@ static int cmp_exact(char *source, int index)
 	SHA224_Final((unsigned char*)crypt_out, &ctx);
 
 #ifdef SIMD_COEF_32
+#if ARCH_LITTLE_ENDIAN
 	alter_endianity(crypt_out, DIGEST_SIZE);
+#endif
 #ifdef REVERSE_STEPS
 	sha224_reverse(crypt_out);
 #endif
diff --git a/src/rawSHA256_fmt_plug.c b/src/rawSHA256_fmt_plug.c
index 4e1367c957..2a8c6c63b8 100644
--- a/src/rawSHA256_fmt_plug.c
+++ b/src/rawSHA256_fmt_plug.c
@@ -87,7 +87,11 @@ john_register_one(&fmt_rawSHA256);
 #endif
 
 #ifdef SIMD_COEF_32
+#if ARCH_LITTLE_ENDIAN==1
 #define GETPOS(i, index)		( (index&(SIMD_COEF_32-1))*4 + ((i)&(0xffffffff-3))*SIMD_COEF_32 + (3-((i)&3)) + (unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*SIMD_COEF_32*4 )
+#else
+#define GETPOS(i, index)		( (index&(SIMD_COEF_32-1))*4 + ((i)&(0xffffffff-3))*SIMD_COEF_32 + ((i)&3) + (unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*4*SIMD_COEF_32 )
+#endif
 static uint32_t (*saved_key);
 static uint32_t (*crypt_out);
 #else
@@ -152,7 +156,9 @@ static void *get_binary(char *ciphertext)
 	}
 
 #ifdef SIMD_COEF_32
+#if ARCH_LITTLE_ENDIAN
 	alter_endianity (out, DIGEST_SIZE);
+#endif
 #ifdef REVERSE_STEPS
 	sha256_reverse(outw);
 #endif
@@ -202,6 +208,7 @@ static void set_key(char *key, int index) {
 	uint32_t temp;
 
 	len = 0;
+#if ARCH_LITTLE_ENDIAN==1
 	while((unsigned char)(temp = *wkey++)) {
 		if (!(temp & 0xff00))
 		{
@@ -222,6 +229,28 @@ static void set_key(char *key, int index) {
 			goto key_cleaning;
 		}
 		*keybuf_word = JOHNSWAP(temp);
+#else
+	while((temp = *wkey++) & 0xff000000) {
+		if (!(temp & 0xff0000))
+		{
+			*keybuf_word = (temp & 0xff000000) | (0x80 << 16);
+			len++;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff00))
+		{
+			*keybuf_word = (temp & 0xffff0000) | (0x80 << 8);
+			len+=2;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff))
+		{
+			*keybuf_word = temp | 0x80U;
+			len+=3;
+			goto key_cleaning;
+		}
+		*keybuf_word = temp;
+#endif
 		len += 4;
 		keybuf_word += SIMD_COEF_32;
 	}
@@ -330,7 +359,9 @@ static int cmp_exact(char *source, int index)
 	SHA256_Final((unsigned char*)crypt_out, &ctx);
 
 #ifdef SIMD_COEF_32
+#if ARCH_LITTLE_ENDIAN
 	alter_endianity(crypt_out, DIGEST_SIZE);
+#endif
 #ifdef REVERSE_STEPS
 	sha256_reverse(crypt_out);
 #endif
